// duz.h - Klasa duzi u ravni.

#ifndef _duz_h_
#define _duz_h_

#include "linija.h"
#include "tacka5.h"
#include <cmath>
using namespace std;

namespace Linije {
  class Duz: public Linija {
    Tacka A, B;                                       // Krajnje tacke.
  public:
    explicit Duz (const Tacka& P=Tacka(-1,-1),        // Konstruktor.
                  const Tacka& Q=Tacka(1,1)): A(P), B(Q) {}
    double operator+ () const                         // Duzina.
      { return sqrt (pow(A.aps()-B.aps(),2) + pow(A.ord()-B.ord(),2)); }
    Linija* kopija () const                           // Dinamicka kopija.
      { return new Duz (*this); }
  private:
    void pisi (ostream& dat) const                    // Pisanje.
      { Linija::pisi (dat); dat << "[duz: A" << A << ", B" << B << ']'; }
  };
}

#endif