// masina.h - Klasa apstraktnih masina.

#ifndef _masina_h_
#define _masina_h_

#include "proizvod.h"

namespace Fabrika {
  class Masina {
    int br;                                 // Broj napravljenih proizvoda.
    virtual Proizvod* napravi () const = 0; // Napravi proizvod.
    Masina (const Masina&) {}               // Ne sme da se kopira.
    void operator= (const Masina&) {}       // Ne sme da se dodeljuje.
  public:
    Masina () { br = 0; }                   // Inicijalizacija.
    virtual char vrsta () const =0;         // Vrsta pravljenih proizvoda.
    Proizvod* operator! ()                  // Napravi proizvod.
      { br++; return napravi (); }
    int broj () const { return br; }        // Broj napravljenih proizvoda.
  }; // class Masina
} // namespace Fabrika

#endif