// predmet3.h - Klasa apstraktnih predmeta.

#ifndef _predmet_h_
#define _predmet_h_

#include <iostream>
#include <iomanip>
#include <typeinfo>
#include <cstring>
using namespace std;

namespace Predmeti {
  class Predmet {
    static int ukId;           // Poslednje korisceni identifikator.
    int id;                    // Identifikator predmeta.
  public:
    Predmet (): id(++ukId) {}             // Novi predmet dobija novi broj.
    Predmet (const Predmet&):id(++ukId){} // Kopija dobija novi broj.
    virtual ~Predmet () {}                // Virtuelni destruktor.
    Predmet& operator= (const Predmet&)   // Levom operandu se ne menja
      { return *this; }                   //   broj.
    virtual Predmet* kopija () const =0;  // Dinamicka kopija.
    virtual double V () const =0;         // Zapremina.
    virtual double Q () const =0;         // Tezina.
    const char* vrsta () const            // Ime klase.
      { return strrchr (typeid(*this).name(), ':') + 1; }
  protected:
    static int nivo;                      // Nivo pisanja predmeta.
    virtual void pisi (ostream& d) const  // Pisanje.
      { d << setw(nivo*2) << "" << vrsta() << '/' << id << ' '; }
    friend ostream& operator<< (ostream& d, const Predmet& p)
      { p.pisi (d); return d; }
  }; // class Predmet
  
  int Predmet::ukId = 0, Predmet::nivo = 0; // Zajednicki atributi.
} // namespace Predmeti

#endif