// radnik.h - Klasa radnika.

#ifndef _radnik_h_
#define _radnik_h_

#include "greska.h"
using Usluge::Greska;
#include "proizvod.h"
#include "masina.h"
#include <iostream>
#include <cstring>
using namespace std;

namespace Fabrika {
  class GNemaMasinu: public Greska {          // KLASA ZA GRESKU:
    char* ime; int id; // Ime i identifikator problematicnog radnika.
    void operator= (const GNemaMasinu&) {}    // Ne sme da se dodeljuje.
  public:
    GNemaMasinu (const char* iime, int iid) { // Inicijalizacija.
      ime = new char [strlen(ime)+1]; strcpy (ime, iime);
      id = iid;
    }
    friend ostream& operator<< (ostream& d, const GNemaMasinu& g) {
      return d << "\n*** Radniku " << g.ime << ", id " << g.id
               << ", nije dodeljena masina ***\n\a";
    }
  }; // class GNemaMasinu

  class Radnik {         // KLASA ZA RADNIKA:
    static int ukId;     // Poslednje korisceni identifikator.
    int id; char* ime;   // Identifikator i ime radnika.
    Masina* mas;         // Masina koju radnik koristi.
    int br;              // Broj napravljenih proizvoda na masini.
    Radnik (const Radnik&) {}               // Ne sme da se kopira.
    void operator= (const Radnik&) {}       // Ne sme da se dodeljuje.
  public:
    Radnik (const char* iime) {             // Inicijalizacija.
      id = ++ukId; mas = 0;
      ime = new char [strlen(iime)+1]; strcpy (ime, iime);
    }
    const char* uzmiIme () const { return ime; } // Dohvatanje imena.
    int uzmiId () const { return id; }      // Dohvatanje identifikator.
    Radnik& operator+= (Masina* m)          // Pridruzivanje masine.
      { mas = m; br = 0; return *this; }
    int broj () const {                     // Broj napravljenih proizvoda.
      if (!mas) throw GNemaMasinu (ime, id);
      return br;
    }
    Proizvod* operator! () {                // Napravi proizvod.
      if (!mas) throw GNemaMasinu (ime, id);
      br++; return !*mas;
    }
    friend ostream& operator<< (ostream& d, const Radnik& r) { // Pisanje.
      d << r.ime << '/' << r.id;
      if (r.mas) d << '(' << r.mas->vrsta() << ',' << r.br << ')';
      return d;
    }
  }; // class Radnik
} // namespace Fabrike.

#endif
