// sklop.C - Metode klase sklopova predmeta.

#include "sklop.h"

namespace Predmeti {
  void Sklop::kopiraj (const Sklop& s) {      // Kopiranje u objekat.
    for (unsigned i=0; i<s.niz.size(); i++)
      niz.push_back (s.niz[i++]->kopija ());
  }

  void Sklop::brisi () {                      // Praznjenje.
    for (unsigned i=0; i<niz.size(); delete niz[i++]);
    niz.clear ();
  }

  void Sklop::pisi (ostream& d) const {       // Pisanje.
    Predmet::pisi (d); d << '[' << endl; nivo++;
    for (unsigned i=0; i<niz.size(); d<<*niz[i++]<<endl);
    --nivo; d << setw (2*nivo+1) << ']';
  }

  double Sklop::V () const {                  // Zapremina.
    double v = 0;
    for (unsigned i=0; i<niz.size(); v+=niz[i++]->V());
    return v;
  }

  double Sklop::Q () const {                  // Tezina.
    double q = 0;
    for (unsigned i=0; i<niz.size(); q+=niz[i++]->Q());
    return q;
  }
} // namespace Predmeti
