// skup2.h - Klasa skupova apstraktnih objekata.

#include "objekat.h"

class Skup {
  struct Elem {                                       // ELEMENT SKUPA
    Obj* obj;                                         //   - sadrzaj
    Elem* sled;                                       //   - sledeci
    Elem (Obj* oo=0, Elem* nn=0) { obj=oo; sled=nn; } //   Konstruktor.
    ~Elem () { delete obj; }                          //   Destruktor.
  };

  Elem *prvi, *posl;                       // Elementi skupa.

  void dodaj   (const Obj& obj) {          // Dodavanje objekta skupu.
    Elem* novi = new Elem (obj.kopija());
    posl = (posl ? posl->sled : prvi) = novi;
  }

  void kopiraj (const Skup& s);            // Kopiranje skupa.
  void brisi   ();                         // Unistavanje skupa.
public:
  Skup () { prvi = posl = 0; }                             // Prazan skup.
  Skup (const Obj &obj)                                    // Konverzija.
    { prvi = posl = new Elem (obj.kopija()); }
  Skup (const Skup& s) { kopiraj (s); }                    // Kopija.
  ~Skup () { brisi (); }                                   // Unistavanje.
  Skup& operator= (const Skup& s) {                        // Dodela.
    if (this != &s) { brisi (); kopiraj (s); }
    return *this;
  }
  bool operator% (const Obj& obj) const;                   // Element skupa?
  friend Skup operator+ (const Skup& s1, const Skup& s2)   // Unija.
    { return Skup(s1) += s2; }
  friend Skup operator- (const Skup& s1, const Skup& s2);  // Razlika.
  friend Skup operator* (const Skup& s1, const Skup& s2);  // Presek.
  Skup& operator+= (const Skup& s);                              // Unija.
  Skup& operator-= (const Skup& s) { return *this = *this - s; } // Razlika.
  Skup& operator*= (const Skup& s) { return *this = *this * s; } // Presek.
  friend ostream& operator<< (ostream& d, const Skup& s);  // Pisanje.
};
